library TestPlugin;

uses
  Windows,
  AutorunPlugin in 'AutorunPlugin.pas';

var
  TCWnd: HWND;
  ParseNext: Pointer;


function FuncRawParam(Params: PAutorunFuncParams): integer; stdcall;

begin

  with Params^ do

  begin

    MessageBox(TCWnd, Params^.Param, 'Raw param string:', 0);
  end;
  Result:=AU_RESULT_OK;

end;


function FuncMultiParam(Params: PAutorunFuncParams): integer; stdcall;

var
  S: string;

  ParamString: PWideChar;

  Buf: array[0..4095] of char;

begin

  with Params^ do

  begin
    ParamString:=Param;

    while TParseNext(ParseNext)(ParamString, Buf) <> AU_PARSER_NOMOREPARAMS do
      S:=S + 'Param: ' + UnicodeString(Buf) + #13#10;

    MessageBox(TCWnd, PWideChar(S), PWideChar('Received params: '+ Param), 0);
  end;
  Result:=AU_RESULT_OK;
end;


function FuncWithReturn(Params: PAutorunFuncParams): integer; stdcall;

begin

  with Params^ do

  begin

    lstrcpyn(Value, PWideChar(WideString(PWideChar(Param)) + '-123456'), MaxLen);

  end;

  Result:=AU_RESULT_OK;

end;


procedure Autorun_PluginInit(Info: PAutorunInterface); export; stdcall;

begin
  with Info^ do
  begin
    TCWnd:=hWnd;
    ParseNext:=pParseNextProc;
    // set some variables
    AddVar(pSetVarProc, 'TESTVAR',   'Vriable value', 0);
    AddVar(pSetVarProc, 'TESTCONST', 'Constant value', AU_VAR_CONSTANT);
    // set functions
    AddFunc(pSetFuncProc, 'FuncRawParam',   @FuncRawParam,   0);
    AddFunc(pSetFuncProc, 'FuncMultiParam', @FuncMultiParam, 0);
    AddFunc(pSetFuncProc, 'FuncWithReturn', @FuncWithReturn, AU_FUNC_RETURNVALUE);
  end;
end;

procedure DllMain(Reason: integer) ;
begin
   case reason of
     DLL_PROCESS_ATTACH:
     begin
       // initialozation code here
     end;
     DLL_PROCESS_DETACH:
     begin
       // finalization code here
     end;
   end;
end;

{------------------------------------------------------------------------------}
exports
  Autorun_PluginInit;


begin
  DllProc:=@DllMain;
  DllProc(DLL_PROCESS_ATTACH);
end.
